﻿using System.IO;
using System.Net;

using MediaPortal.Configuration;
using MediaPortal.GUI.Library;
using MediaPortal.Util;


namespace MyKindGirls
{
    public class FetchPictureFromLink
    {
        private string thumbspath = Config.GetFolder(Config.Dir.Thumbs) + "\\KindGirls\\";
        private string cachepath = Config.GetFolder(Config.Dir.Cache) + "\\KindGirls\\";

        public FetchPictureFromLink()
        {
            Log.Debug("thumbspath: " + thumbspath);
            Log.Debug("cachepath: " + cachepath);

            if (!System.IO.Directory.Exists(thumbspath)) System.IO.Directory.CreateDirectory(thumbspath);
            if (!System.IO.Directory.Exists(cachepath)) System.IO.Directory.CreateDirectory(cachepath);
        }

        public void Fetch(string Link)
        {
            string fname = Path.GetFileName(Link);

            if (!System.IO.File.Exists(thumbspath + fname))
            {
              try
              {
                WebClient client = new WebClient();
                client.Headers.Add("user-agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.2; .NET CLR 1.0.3705;)");
                Log.Debug("Downloading [" + Link + "] to [" + thumbspath + fname + "]");
                client.DownloadFile(Link, thumbspath + fname);

                Thumbnail(fname);
              }
              catch { }
            }
        }

        public void Thumbnail(string filename)
        {
            Log.Debug("Thumbnail [" + filename + "]");
            System.Drawing.Bitmap org = new System.Drawing.Bitmap(thumbspath + filename);
            Log.Debug("Creating thumbnail of [" + thumbspath + filename + "] to [" + cachepath + filename + "]");
            Picture.CreateThumbnail(org, cachepath + filename, (int)Thumbs.ThumbLargeResolution, (int)Thumbs.ThumbLargeResolution, 0, false);
            org.Dispose();
        }
    }
}
