﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Windows.Forms;

using MediaPortal.GUI.Library;
using MyKindGirls.Database;

namespace MyKindGirls
{
    class KindGirlsScraper
    {
        private FetchPictureFromLink fetcher = new FetchPictureFromLink();

        public void ScrapeSite(System.Windows.Forms.ProgressBar progressBar, System.Windows.Forms.Label lbl_percent, System.Windows.Forms.Label lbl_actual, decimal value)
        {
            IKindGirlsDatabase _database = DatabaseFactory.GetKindGirlsDatabase();
            List<string> models = new List<string>();
            _database.ListModels(ref models);

            try
            {
                // http://www.kindgirls.com/photo-archive

                List<string> firstPage = new List<string>();
                List<string[]> modelPages = new List<string[]>();
                List<string[]> picturePages = new List<string[]>();
                List<string[]> pictureLinks = new List<string[]>();

                int x = 0;
                int y = 0;
                int count = 0;

                #region MainPage

                lbl_actual.Text = "Scanning Main Page";

                Request req = new Request("http://www.kindgirls.com/photo-archive");
                string mainPage = req.PostData();

                // Bereich = <div id='date_search' </div

                x = mainPage.IndexOf("<select");
                if (x > 0)
                {
                    // found start
                    y = mainPage.IndexOf("</select>", x);
                    if (y > 0)
                    {
                        // found end, store area
                        string page = mainPage.Substring(x, y - x);

                        x = 0;
                        while (x >= 0)
                        {
                            // parse for links
                            x = page.IndexOf("value=\"", x);
                            if (x >= 0)
                            {
                                y = page.IndexOf("\">", x + 1);
                                if (y > 0)
                                {
                                    string link = page.Substring((x + 7), y - (x + 7));
                                    firstPage.Add("http://www.kindgirls.com/photo-archive?s=" + link);
                                    Log.Debug("Found link http://www.kindgirls.com/photo-archive?s=" + link);
                                }
                                x++;
                            }

                        }
                        Log.Info("--> Found " + firstPage.Count + " links");
                    }
                }

                #endregion

                // firstpage links = http://www.kindgirls.com/photo-archive?s=02-2010

                #region scan pages

                lbl_actual.Text = "Scanning Month Archive";

                foreach (string link in firstPage)
                {
                    Log.Debug("Work on " + link[0]);

                    req = new Request(link);
                    string thisPage = req.PostData();

                    //  <div class="gallery_list">

                    x = 0;

                    while (x >= 0)
                    {
                        x = thisPage.IndexOf("<div class=\"gallery_list\">", x);
                        if (x > 0)
                        {
                            // found start
                            y = thisPage.IndexOf("</div>", x);
                            if (y > 0)
                            {
                                // found end, store data
                                string oneLink = thisPage.Substring(x, y - x);
                                string nextTitle = "";

                                // parse for model title
                                int x1 = oneLink.IndexOf("alt=");
                                if (x1 >= 0)
                                {
                                    int y1 = oneLink.IndexOf("\" />", x1 + 4);
                                    if (y1 > 0)
                                    {
                                        nextTitle = oneLink.Substring((x1 + 4), y1 - (x1 + 4));
                                        nextTitle = nextTitle.Replace("\"", "");
                                        nextTitle = nextTitle.Replace("'", "");
                                        Log.Debug("Found title " + nextTitle);
                                    }
                                }

                                // parse for link
                                int x2 = oneLink.IndexOf("href=");
                                if (x2 >= 0)
                                {
                                    int y2 = oneLink.IndexOf(">", x2 + 5);
                                    if (y2 > 0)
                                    {
                                        string nextPage = oneLink.Substring((x2 + 5), y2 - (x2 + 5));
                                        nextPage = nextPage.Replace("\"", "");
                                        nextPage = nextPage.Replace("'", "");
                                        
                                        // check if model already is in DB
                                        if (!models.Contains(nextTitle))
                                        {
                                            modelPages.Add(new string[2] { "http://www.kindgirls.com" + nextPage, nextTitle });
                                            Log.Debug("Found model http://www.kindgirls.com" + nextPage);
                                        }
                                        else
                                            Log.Debug("Ignored exsisting model: " + nextTitle);
                                    }
                                }
                            }
                            x++;
                        }
                    }

                    count++;
                    if (count == value) break;

                    double p = (double)count / (double)value * 100;
                    progressBar.Value = (int)p;

                    Application.DoEvents();
                }

                Log.Info("Found " + modelPages.Count + " models");

                #endregion

                // links to picture pages = http://www.kindgirls.com/gallery/hegre/gabriella_marlene_93404/gabriella-marlene/12/02-2010

                #region scan picture pages

                lbl_actual.Text = "Scanning Models";

                count = 0;

                foreach (string[] link in modelPages)
                {
                    count++;
                    lbl_actual.Text = "Scanning Models [" + count + "/" + modelPages.Count + "]";

                    double p = (double)count / (double)modelPages.Count * 100;
                    progressBar.Value = (int)p;
                    lbl_percent.Text = ((int)p) + "%";

                    Application.DoEvents();

                    Log.Debug("Work on " + link[0]);

                    req = new Request(link[0]);
                    string thisPage = req.PostData();

                    //  <div class="gallery_list">

                    x = 0;
                    while (x >= 0)
                    {
                        x = thisPage.IndexOf("<div class=\"gallery_list\">", x);
                        if (x > 0)
                        {
                            // found start
                            y = thisPage.IndexOf("</div", x);
                            if (y > 0)
                            {
                                // found end, store data
                                string oneLink = thisPage.Substring(x, y - x);
                                string nextTitle = "";

                                // parse for title
                                int x1 = oneLink.IndexOf("alt=");
                                if (x1 >= 0)
                                {
                                    int y1 = oneLink.IndexOf("\" />", x1 + 4);
                                    if (y1 > 0)
                                    {
                                        nextTitle = oneLink.Substring((x1 + 4), y1 - (x1 + 4));
                                        nextTitle = nextTitle.Replace("\"", "");
                                        nextTitle = nextTitle.Replace("'", "");
                                        Log.Debug("Found picture title " + nextTitle);
                                    }
                                }

                                // parse for links
                                int x2 = oneLink.IndexOf("href=");
                                if (x2 >= 0)
                                {
                                    int y2 = oneLink.IndexOf(">", x2 + 5);
                                    if (y2 > 0)
                                    {
                                        string nextPage = oneLink.Substring((x2 + 5), y2 - (x2 + 5));
                                        nextPage = nextPage.Replace("\"", "");
                                        nextPage = nextPage.Replace("'", "");
                                        picturePages.Add(new string[3] { "http://www.kindgirls.com" + nextPage, nextTitle, link[1] });
                                        Log.Debug("Found picture page http://www.kindgirls.com" + nextPage);
                                    }
                                }
                            }
                            x++;
                        }
                    }

                    // test
                    // break;

                }

                Log.Info("Found " + picturePages.Count + " picture pages");

                #endregion

                // links to picture  = <img src="/gal-00211/gabriella_marlene_93404/thumbnails/tngabriella_marlene_93404_1.jpg"

                #region scan picture

                lbl_actual.Text = "Scanning Photos";

                count = 0;

                foreach (string[] link in picturePages)
                {
                    count++;
                    lbl_actual.Text = "Scanning Photo [" + count + "/" + picturePages.Count + "]";

                    double p = (double)count / (double)picturePages.Count * 100;
                    progressBar.Value = (int)p;
                    lbl_percent.Text = ((int)p) + "%";

                    Application.DoEvents();

                    Log.Debug("Work on " + link[0]);

                    req = new Request(link[0]);
                    string thisPage = req.PostData();

                    //  <img src='/galh450p/emma_31968/emma_31968_15.jpg'

                    x = 0;

                    x = thisPage.IndexOf("<img src=", x);
                    if (x > 0)
                    {
                        // found start
                        y = thisPage.IndexOf("'", x + 10);
                        if (y > 0)
                        {
                            // found end, store data
                            string nextPage = thisPage.Substring((x + 10), y - (x + 10));
                            nextPage = nextPage.Replace("\"", "");
                            nextPage = nextPage.Replace("'", "");
                            pictureLinks.Add(new string[3] { "http://www.kindgirls.com" + nextPage, link[1], link[2] });
                            Log.Debug("Found picture http://www.kindgirls.com" + nextPage);
                        }
                        x++;
                    }
                }

                Log.Info("Found " + pictureLinks.Count + " pictures");

                #endregion

                #region save results

                foreach (string[] link in pictureLinks)
                {
                    string fname = Path.GetFileName(link[0]);
                    _database.AddPicture(link[0], fname, link[2], link[1]);
                }
                _database.Dispose();

                #endregion

                #region Download pictures

                int cacheCount = pictureLinks.Count;

                for (int i = 0; i < cacheCount; i++)
                {
                    lbl_actual.Text = "Downloading Photo [" + (i+1) + "/" + cacheCount + "]";

                    double p = (double)(i+1) / (double)cacheCount * 100;
                    progressBar.Value = (int)p;
                    lbl_percent.Text = ((int)p) + "%";

                    Application.DoEvents();
                    progressBar.Refresh();

                    string[] link = pictureLinks[i];
                    {
                        fetcher.Fetch(link[0]);
                    }
                }

                #endregion
            }
            catch (Exception ex)
            {
                lbl_actual.Text = "error";
                throw (ex);
            }
        }
    }
}
